/**
 * This class centralize the pfc resources (translated messages, images, themes ...)
 * (no longer depends on prototype library - see below)
 * @author Stephane Gully
 *
 *This file was Modified by Rob Gravelle (Vizimetrics, Inc) in January 2009 to use MooTools instead of Prototype.
 *All modified code is released under the LGPL, Copyright 2009 Vizimetrics, Inc.  <tim@vizimetrics.com>
 */
var pfcResource = new Class({
  
  initialize: function()
  {
    this.labels  = $H();
    this.fileurl = $H();
    this.smileys = $H();
    this.smileysreverse = $H();
    this.smileyskeys = new Array();
  },

  setLabel: function(key, value)
  {
    this.labels.set(key,value);
  },

  getLabel: function()
  {
    var key = this.getLabel.arguments[0];
    if (this.labels.get(key))
    {
      this.getLabel.arguments[0] = this.labels.get(key);
      return String.sprintf2(this.getLabel.arguments);
    }
    else
      return '_'+key+'_';
  },

  setFileUrl: function(key, value)
  {
    this.fileurl.set(key,value);
  },
  
  getFileUrl: function(key)
  {
    if (this.fileurl.get(key))
      return this.fileurl.get(key);
    else
      return "";
  },

  setSmiley: function(key, value)
  {
    this.smileys.set(key, value);
    this.smileysreverse.set(value,key);
    this.smileyskeys.push(key);
  },
  getSmiley: function(key)
  {
    if (this.smileys.get(key))
      return this.smileys.get(key);
    else
      return "";
  },
  getSmileyHash: function()
  {
    return this.smileys;
  },
  getSmileyReverseHash: function()
  {
    return this.smileysreverse;
  },
  getSmileyKeys: function()
  {
    return this.smileyskeys;
  },
  sortSmileyKeys: function()
  {
    // Sort keys by longest to shortest. This prevents a smiley like :) from being used on >:)
    return this.smileyskeys.sort(
        function (a,b)
        {
          var x = a.unescapeHTML();
          var y = b.unescapeHTML();
    
          return (y.length - x.length);
        }
    );
  }
});


